unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,  StdCtrls, ComCtrls,
  Graph64, Screen64,  ExtDlgs, ExtCtrls, Spin;

const
  Bpp = Graphics.pf32bit;
  
type
  TForm1 = class(TForm)
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    ListBox1: TListBox;
    TransparentBox: TCheckBox;
    PaintBox1: TPaintBox;
    TrackBar1: TTrackBar;
    Button2: TButton;
    CheckBox1: TCheckBox;
    OpenPictureDialog1: TOpenPictureDialog;
    TrackBar2: TTrackBar;
    Label3: TLabel;
    ListBox2: TListBox;
    Label4: TLabel;
    Label5: TLabel;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure TransparentBoxClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }

    Deep: Integer;
    
    StartX, StartY,
    MouseX,MouseY: Integer;

    back_bmp,
    bmp,
    ge_bmp,
    alpha: TBitmap;

    Image: TBitmap;
    AlphaScr,
    Scr,Scr2,Scr3: TScreen64;
    BlendingMode,
    FilteringMode: Integer;
    procedure Render;
    procedure Load(Level: Integer);

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Load(Level: Integer);
var
  s: Array[0..1] of string;
begin
  s[0] := 'logo1.bmp';
  s[1] := 'back3.bmp';
  bmp.PixelFormat := Bpp;
  bmp.Width := PaintBox1.Width;
  bmp.Height := PaintBox1.Height;

  ge_bmp.LoadFromFile(s[0]);
  ge_bmp.PixelFormat := bpp;

  back_bmp.LoadFromFile(s[1]);
  back_bmp.PixelFormat := bpp;

  alpha.LoadFromFile('alpha_2.bmp'); //we doesn't need to convert because bitmap
  alpha.PixelFormat := Graphics.pf8bit; //alpha must be only 8bpp!!! (256colors)!

  Scr.LinkToTBitmap(bmp);   // link to existing TBitmap and that's all!
  AlphaScr.LinkToTBitmap(alpha);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BlendingMode := bmCopy;
  FilteringMode := fmNone;
  StartX := 0;
  StartY := 0;
  
  // First create some surfaces like normal
  // BUT YOU MUST SETUP PixelFormat!! Default TBitmap pixel format is
  // pf24bit whitch Graph64 GE doen't support now (It's tooo slow!!)
  // you can choose from pf15bit or pf32bit
  bmp := TBitmap.Create;   //create renderer TBitmap

  ge_bmp := TBitmap.Create;     //Load background in ge_bmp (into TBitmap object)
  back_bmp := TBitmap.Create;
  alpha := TBitmap.Create;

  Scr := TScreen64.Create;  // now create TScreen64 bitmap!
  Scr2 := TScreen64.Create; //temporary handler
 

  AlphaScr := TScreen64.Create;
  ListBox1.ItemIndex := 0;
  ListBox2.ItemIndex := 0;
  
  Load(1);
end;

procedure TForm1.Render;
// this procedure render main feature of engine
var
  x,i: Integer;
  b: TBlendSpec;
  rgb: TRGBSpec;
  Dis2,Dis: Byte;
  w: Integer;
  r: TRect;
  TopColor,
  BottomColor: Integer;
  trans,trans1: TTransformSpec;
  t1,t2: Cardinal;
  Axial : TAxialSpec;
  
begin
  t1 := GetTickCount;
  //first, render background with copy mode
  Scr2.LinkToTBitmap(back_bmp);
  Scr2.Transparent := False;

  Scr.BlendMode := bmCopy;
  Scr.BlendFilterMode := fmNone; //disable filter mode

  for x := 0 to (Scr.Width div Scr2.Width) + 1 do
    for i := 0 to (Scr.Height div Scr2.Height) + 1 do
      Scr.Draw(x * Scr2.Width, i * Scr2.Height, Scr2);

  //now render image (ge.bmp)
  Scr2.LinkToTBitmap(ge_bmp);
  Scr2.TransparentColor := Scr2.Pixels[0,0]; //top left pixel is transparent color


  // apply filter mode
  case FilteringMode of
    0:  //fmNone
        Scr.BlendFilterMode := fmNone;
    1:  //fmDisolve
      begin
        Scr.BlendFilterMode := fmDisolve;
        Dis2 := TrackBar2.Position;
        Scr.BlendFilterParams := @Dis2;
      end;
    2:  //fmAlphaTransform
      begin
        trans1.alpha := AlphaScr;
        trans1.frame := 255 - Trunc(TrackBar2.Position * 2.55);
        Scr.BlendFilterMode := fmAlphaTransform;
        Scr.BlendFilterParams := @trans1;
      end;
  end;

  // paint a shadow
{  Scr.BlendMode := bmShadow;
  w := Scr.rgb(0, 0, 0);
  Scr.BlendParams := @w;
  Scr2.Transparent := True;
  for i := 0 to 11 do
    Scr.Draw(1 + StartX + i * (Scr2.Width)+ 5, 1 +
      StartY + 20, Scr2);
}
  Scr2.Transparent := TransparentBox.Checked;;

  case BlendingMode of
    0:  //copy mode
      Scr.BlendMode := bmCopy;
    1:  //disolve mode
      begin
        Scr.BlendMode := bmDisolve;
        Dis := TrackBar1.Position;
        Scr.BlendParams := @Dis;
      end;
    2:  // "lens" mode 50/50 of each pixel
      Scr.BlendMode := bmLens;
    3:  //grayscale
      begin
        Scr.BlendMode := bmGrayscale;
      end;
    4: //blending 0.1/0.9
      begin
        Scr.BlendMode := bmBlend;
        b.sfactor := TrackBar1.Position / 100;
        b.dfactor := 1 - TrackBar1.Position / 100;
        Scr.BlendParams := @b;
      end;
    5: //blending 1/1
      begin
        Scr.BlendMode := bmBlend;
        b.sfactor :=  TrackBar1.Position / 100;
        b.dfactor := 1;
        Scr.BlendParams := @b;
      end;
    6:  //add lightness to rgb colors (r:0 g:155 b:0)
      begin
        rgb.Red := 0;
        rgb.Green:= 0;
        rgb.Blue := Trunc(TrackBar1.Position*2.55);
        Scr.BlendMode := bmLightness;
        Scr.BlendParams := @rgb;
      end;
    7:  //remove lightness from rgb colors (r:0 g:155 b:0)
      begin
        rgb.Red := Trunc(TrackBar1.Position*2.55);
        rgb.Green:= Trunc(TrackBar1.Position*2.55);
        rgb.Blue := Trunc(TrackBar1.Position*2.55);
        Scr.BlendMode := bmDarkness;
        Scr.BlendParams := @rgb;
      end;
    8: //alpha transform
      begin
        trans.alpha := AlphaScr;
        trans.frame := 255 - Trunc(TrackBar1.Position * 2.55);
        Scr.BlendMode := bmAlphaTransform;
        Scr.BlendParams := @trans;
      end;
    9: //Shadow
      begin
        Scr.BlendMode := bmShadow;
        i := Trunc(TrackBar1.Position * 2.55);
        w := Scr.rgb(i, i, i);
        Scr.BlendParams := @w;
      end;
   10:
      begin
        Scr.BlendMode := bmAxialBlend;
        Axial.AStart := TrackBar1.Position;
        Axial.AMiddle := 0;
//        Axial.AMiddle := 100 - StartY;
//        if Axial.AMiddle < 0 then Axial.AMiddle := 0;
        Axial.AEnd := 100 - TrackBar1.Position;
        Scr.BlendParams := @Axial;
      end;
  end;

  for i := 0 to 11 do
    Scr.Draw(StartX + i * (Scr2.Width)+ 5,
      StartY + 20, Scr2);

  Scr.BlendFilterMode := fmNone; //disable filter for other painting methods

//  Deep :=  2;
  Deep := SpinEdit1.Value;
  Scr.PaintMode := bmLens;

  r := Rect(0 + Deep, 0 + Deep, 220 + Deep, 18 + Deep);
  Scr.FillRect(r, Scr.rgb(25,0,255));
  Scr.PaintMode := bmCopy;
  Scr.Rectangle(r, Scr.rgb(0,0,0));

  bmp.Canvas.Brush.Style := bsClear;
  bmp.Canvas.Font.Color := clWhite;

  bmp.Canvas.TextOut(2 + Deep, 2 + Deep, ListBox1.Items.Strings[ListBox1.ItemIndex]);

  Scr.PaintMode := bmLens;

  for x := 0 to Deep do
  begin
{    TopColor := Scr.rgb(255-x*2, 255-x*2, 255-x*2);
    BottomColor := Scr.rgb(120-x*2, 120-x*2, 120-x*2);}
    TopColor := Scr.rgb(255,255,255);
    BottomColor := Scr.rgb(0,0,0);

    Scr.HLine(x,x, Scr.Width-(x+1), TopColor);
    Scr.HLine(x,Scr.Height -(x + 1), Scr.Width - (x + 1), BottomColor);

    Scr.VLine(x,x, Scr.Height - (x + 1), TopColor);
    Scr.VLine(Scr.Width -1 - x, x, Scr.Height- (x + 2), BottomColor);
  end;
  //as you can see you can still work with your TBitmap like normal Delphi do
  t2 := GetTickCount;
  bmp.Canvas.TextOut(2 + Deep, 32 + Deep, IntToStr(t2 - t1));
  try
    PaintBox1.Canvas.Draw(0, 0, bmp);
  finally  
  end;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
  begin
    try
      bmp.SaveToFile(SaveDialog1.FileName);
    except
      MessageDlg('Some problems with write image :(', mtInformation, [mbOk], -1);
    end;
  end;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  BlendingMode := ListBox1.ItemIndex;
  Render;
end;

procedure TForm1.TransparentBoxClick(Sender: TObject);
begin
  Render;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  Render;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 if OpenPictureDialog1.Execute then
 begin
   try
     ge_bmp.LoadFromFile(OpenPictureDialog1.FileName);
     ge_bmp.PixelFormat := bpp;
   finally
     Render;
   end;
 end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
  begin
    PaintBox1.Width := 300;
    PaintBox1.Height := 73;
  end
  else
  begin
    PaintBox1.Width := 753;
    PaintBox1.Height := 289;
  end;
  try
  bmp.Width := PaintBox1.Width;
  bmp.Height := PaintBox1.Height;
  Scr.LinkToTBitmap(bmp);
  finally
    Render;
  end;

end;

procedure TForm1.ListBox2Click(Sender: TObject);
begin
  FilteringMode := ListBox2.ItemIndex;
  Render;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  PaintBox1.Canvas.Draw(0, 0, bmp);
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  Render;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if (ssLeft in Shift) then
  begin
    Dec(StartX, MouseX - X);
    Dec(StartY, MouseY - Y);
    MouseX := X;
    MouseY := Y;
    Render;
  end;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  MouseX := X;
  MouseY := Y;
end;

end.
