unit IconSelector;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, StdCtrls, ExtCtrls,FileShortCut;

type
  TFormIconSelector = class;

  TMyScrollBox = class(TScrollBox) //class(TScrollingWinControl)
  private
    FOwner:TFormIconSelector;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
  end;

  TFormIconSelector = class(TForm)
    IconOpenDialog: TOpenDialog;
    Label1: TLabel;
    BotonOpen: TButton;
    BotonOk: TButton;
    BotonCancel: TButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BotonOpenClick(Sender: TObject);
    procedure BotonCancelClick(Sender: TObject);
    procedure BotonOkClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    lista:TList;
    ISdc:HDC;
    FormDC:HDC;
    FormPen:HPen;
    FormFont:HFont;
    FormBrush:HBrush;
    ISpen:HPen;
    ISbrush:HBRUSH;
    ISlb:LOGBRUSH;
    ISPenDelete:HPen;
    MyScrollBox:TMyScrollBox;
    OldAppMsgHandle:TMessageEvent;
    isOk:boolean;
    procedure ImgClick(Sender:TObject);
    procedure PrintFileName;
    procedure PintaBorde(im:TImage;pen:HPen);
    procedure AppMessage(var Msg: TMsg;var Handled:boolean);
    procedure AbreIconos(nombre:TFileName);
  public
    { Public declarations }
    FileName:String;
    Actual:integer;
    function Execute(sci:TSCIcon):boolean;
  end;

var
  FormIconSelector: TFormIconSelector;

implementation
uses ShellAPI;
{$R *.dfm}
const
     OffsetX      = 12;
     OffsetY      = 10;
     ICONWIDTH    = 32;

procedure TFormIconSelector.PintaBorde(im:TImage;pen:HPen);
begin
     selectObject(ISdc,pen);
     rectangle(ISdc,im.left-4,im.top-4,im.left+ICONWIDTH+4,im.Top+im.Height+4);
end;

procedure TFormIconSelector.ImgClick(sender:TObject);
begin
     if (MyScrollBox.Enabled) and (MyScrollBox.Visible) and (visible) then
        MyScrollBox.SetFocus;
     if TImage(sender).Tag <> Actual then
     begin
          Label1.Caption:='Icon '+IntToStr(TImage(Sender).Tag);
          if Actual > -1 then
             PintaBorde(TImage(lista[Actual]),ISPenDelete);
          PintaBorde(TImage(sender),ISPen);
          Actual:=TImage(sender).Tag;
          if (TImage(lista[Actual]).Left+ICONWIDTH) > MyScrollBox.ClientWidth then
          begin
               MyScrollBox.ScrollInView(TImage(lista[Actual]));
               MyScrollBox.HorzScrollBar.Position:=MyScrollBox.HorzScrollBar.Position+OffsetX;
          end
          else if (TImage(lista[Actual]).Left < 0) then
          begin
               MyScrollBox.ScrollInView(TImage(lista[Actual]));
               MyScrollBox.HorzScrollBar.Position:=MyScrollBox.HorzScrollBar.Position-OffsetX;
          end

     end;
end;


procedure TFormIconSelector.FormCreate(Sender: TObject);
begin
     isOk:=true;
     Lista:=TList.Create;
     MyScrollBox:=TMyScrollBox.Create(self);
     with MyScrollBox do
     begin
          Parent:=self;
          FOwner:=self;
          Color:=clWindow;
          Height:=72;
          HorzScrollBar.Smooth:=true;
          HorzScrollBar.Tracking:=true;
          HorzScrollBar.Style:=ssHotTrack;
          Left:=3;
          Top:=4;
          VertScrollBar.Visible:=false;
          Width:=344;
          TabStop:=true;
          TabOrder:=4;
          Enabled:=false;
     end;

     FormDC:=GetDC(self.Handle);
     FormPen:=self.Canvas.Pen.Handle;
     FormFont:=self.Canvas.Font.Handle;
     FormBrush:=self.Canvas.Brush.Handle;
     SelectObject(FormDC,FormFont);
     SelectObject(FormDC,FormPen);
     selectObject(FormDC,FormBrush);
     setbkMode(FormDC,TRANSPARENT);
     ISdc:=GetDC(MyScrollBox.Handle);
     ISpen:=CreatePen(PS_SOLID,2,clBlack);
     ISPenDelete:=CreatePen(PS_SOLID,2,GetSysColor(COLOR_WINDOW));
     ISlb.lbStyle:=BS_HOLLOW;
     ISbrush:=CreateBrushIndirect(ISlb);
     selectObject(ISdc,ISbrush);

     Actual:=-1;
     OldAppMsgHandle:=Application.OnMessage;
     Application.OnMessage:=AppMessage;
end;

procedure TFormIconSelector.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
   i:integer;
begin
     for i:=0 to Lista.Count-1 do
         TImage(lista.Items[i]).Free;
     lista.Free;

     releaseDC(handle,FormDC);

     deleteObject(ISpen);
     deleteObject(ISbrush);
     releaseDC(MyScrollBox.Handle,ISdc);
     MyScrollBox.free;
     Application.OnMessage:=OldAppMsgHandle;
end;

procedure BorraLista(var L:Tlist);
var
   i:integer;
begin
     for i:=0 to l.Count-1 do
         TImage(l[i]).Free;
     l.Clear;
end;

procedure TFormIconSelector.BotonOpenClick(Sender: TObject);
begin
     if IconOpenDialog.Execute then
     begin
          AbreIconos(IconOpenDialog.FileName);
     end;
end;

procedure TFormIconSelector.AbreIconos(nombre:TFileName);
var
   i:integer;
   numIcons:integer;
   nom:array [0..511] of char;
   id:integer;
   icon:TIcon;
   img:TImage;
   despl:integer;
begin
     despl:=OffsetX;

     icon:=TIcon.Create;
     try
        id:=-1;
        StrPCopy(Nom,Nombre);
        NumIcons:=extractIcon(hInstance,Nom,Id);
        if NumIcons > 0 then
        begin
             MyScrollBox.Enabled:=false;
             BotonOpen.Enabled:=false;
             BotonOk.Enabled:=false;
             BotonCancel.Enabled:=false;
             application.ProcessMessages;
             Label2.Caption:=IntToStr(NumIcons)+' Icon';
             if NumIcons > 1 then
                Label2.caption:=Label2.caption+'s';
             FileName:=Nombre;
             if Actual <> -1 then
                PintaBorde(TImage(lista[Actual]),ISPenDelete);
             BorraLista(lista);
             PrintFileName;
             img:=nil; // just avoid compiler warning
             Actual:=-1;
             for i:=0 to NumIcons-1 do
             begin
                  img:=TImage.Create(MyScrollBox);
                  Img.Height:=ICONWIDTH;
                  Img.Width:=ICONWIDTH;
                  img.Parent:=MyScrollBox;
                  Img.Top:=OffsetY;
                  Img.Left:=despl;
                  Img.Tag:=i;
                  Img.OnClick:=imgClick;
                  Img.OnDblClick:=BotonOKClick;
                  icon.Handle:=ExtractIcon(hInstance,Nom,i);
                  Img.picture.Icon.Assign(icon);
                  lista.Add(img);
                  despl:=despl+OffsetX+img.Width;
                  application.ProcessMessages;
             end;
             if ((img.Left+Img.Width) > MyScrollBox.ClientWidth) then
                img.Width:=img.Width+OffsetX;
             MyScrollBox.Enabled:=true;
             BotonOpen.enabled:=true;
             BotonOk.Enabled:=true;
             BotonCancel.Enabled:=true;
             imgClick(TImage(Lista[0]));
        end
        else
            Application.MessageBox('No icons found','IconSelector',mb_OK);
     finally
            icon.Free
     end;
end;

procedure TFormIconSelector.BotonCancelClick(Sender: TObject);
begin
     isOk:=false;
     close;
end;

procedure TFormIconSelector.BotonOkClick(Sender: TObject);
begin
     close;
end;

procedure TFormIconSelector.PrintFileName;
var
   rect:TRect;
   c:TColor;
begin
     rect.Left:=Label1.Left;
     Rect.Top:=Label1.Top+Label1.Height+2;
     Rect.Right:=self.ClientWidth-6;
     Rect.Bottom:=Rect.Top+Label1.Height;
     c:=canvas.Pen.Color;
     canvas.Pen.Color:=canvas.Brush.Color;
     canvas.Rectangle(rect);
     canvas.Pen.Color:=c;
     DrawText(FormDC,PChar(FileName),length(FileName),rect,DT_SINGLELINE or DT_PATH_ELLIPSIS);
end;

procedure TFormIconSelector.FormPaint(Sender: TObject);
begin
     PrintFileName;
end;

procedure TFormIconSelector.AppMessage(var Msg: TMsg;var Handled:boolean);
begin
     handled:=false;
     if (msg.message = WM_KEYDOWN) and (Screen.ActiveControl is TMyScrollBox) then
     begin
          case msg.wParam of
               VK_RIGHT:begin
                   if Actual < (lista.Count-1) then
                   begin
                        ImgClick(TImage(lista[Actual+1]));
                   end;
                   handled:=true;
               end;
               VK_LEFT:begin
                   if Actual >0 then
                   begin
                        ImgClick(TImage(lista[Actual-1]));
                   end;
                   handled:=true;
               end;
               VK_HOME:begin
                   ImgClick(TImage(lista[0]));
               end;
               VK_END:begin
                   ImgClick(TImage(lista[lista.Count-1]));
               end;
          end
     end;
end;

function TFormIconSelector.Execute(sci:TSCIcon):boolean;
begin
     result:=false;
     if (sci.IconIndex <> -1) and (sci.IconLocation <> '') then
     begin
          AbreIconos(sci.IconLocation);
          try
             ImgClick(TImage(lista[sci.IconIndex]));

             MyScrollBox.ScrollInView(TImage(lista[sci.IconIndex]));
          except
                ImgClick(TImage(lista[0]));
          end;
     end;

     ShowModal;
     if isOk then
        result:=true;
end;

////////////////////////////////////////////////
// TMyScrollBox ////////////////////////////////
////////////////////////////////////////////////

procedure TMyScrollBox.WMPaint(var Message: TWMPaint);
begin
     inherited;
     if (FOwner.lista.Count > 0) and (FOwner.Actual > -1) then
        FOwner.PintaBorde(TImage(FOwner.lista[FOwner.Actual]),FOwner.ISPen);
end;


procedure TFormIconSelector.FormShow(Sender: TObject);
begin
     if MyScrollBox.Enabled then
        MyScrollBox.SetFocus;
end;

end.
